searchNodes=[{"doc":"Sistema de Transferência de Arquivos The STA context. It communicates with Bacen's STA (Sisbacen) WebService.","ref":"Bacen.STA.html","title":"Bacen.STA","type":"module"},{"doc":"Creates a new protocol and sends it to Bacen's STA WebService. Examples iex&gt; attrs = %{ iex&gt; parameters : %{ iex&gt; file_size : 1234 , iex&gt; file_name : &quot;foo&quot; , iex&gt; file_type : &quot;ACCS001&quot; , iex&gt; hash : &quot;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&quot; iex&gt; } iex&gt; } iex&gt; Mox . stub_with ( Bacen.STA.ClientMock , FakeBacenSTA ) iex&gt; Bacen.STA . create_protocol ( attrs ) { :ok , &quot;123456789&quot; } iex&gt; attrs = %{ iex&gt; parameters : %{ iex&gt; file_size : 1234 , iex&gt; file_name : &quot;invalid_xml&quot; , iex&gt; file_type : &quot;ACCS001&quot; , iex&gt; hash : &quot;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&quot; iex&gt; } iex&gt; } iex&gt; Mox . stub_with ( Bacen.STA.ClientMock , FakeBacenSTA ) iex&gt; Bacen.STA . create_protocol ( attrs ) { :error , :invalid_xml } iex&gt; attrs = %{ iex&gt; parameters : %{ iex&gt; file_size : 1234 , iex&gt; file_name : &quot;error&quot; , iex&gt; file_type : &quot;ACCS001&quot; , iex&gt; hash : &quot;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&quot; iex&gt; } iex&gt; } iex&gt; Mox . stub_with ( Bacen.STA.ClientMock , FakeBacenSTA ) iex&gt; Bacen.STA . create_protocol ( attrs ) { :error , [ %{ attr : [ ] , name : :Resultado , value : [ %{ attr : [ ] , name : :Erro , value : [ &quot;bad request&quot; ] } ] } ] }","ref":"Bacen.STA.html#create_protocol/1","title":"Bacen.STA.create_protocol/1","type":"function"},{"doc":"Sends a file content for given protocol number to Bacen's STA WebService. Examples iex&gt; Mox . stub_with ( Bacen.STA.ClientMock , FakeBacenSTA ) iex&gt; Bacen.STA . send_file_content ( &quot;123456789&quot; , &quot;some long file content&quot; ) :ok iex&gt; Mox . stub_with ( Bacen.STA.ClientMock , FakeBacenSTA ) iex&gt; Bacen.STA . send_file_content ( &quot;123456789&quot; , &quot;wrong file content&quot; ) { :error , [ %{ attr : [ ] , name : :Resultado , value : [ %{ attr : [ ] , name : :Erro , value : [ &quot;bad request&quot; ] } ] } ] }","ref":"Bacen.STA.html#send_file_content/2","title":"Bacen.STA.send_file_content/2","type":"function"},{"doc":"Checks if system is defined to use the staging server Examples iex&gt; Application . put_env ( :bacen_sta , :test_mode , true ) iex&gt; Bacen.STA . test? ( ) true iex&gt; Application . put_env ( :bacen_sta , :test_mode , false ) iex&gt; Bacen.STA . test? ( ) false","ref":"Bacen.STA.html#test?/0","title":"Bacen.STA.test?/0","type":"function"},{"doc":"The Bacen's STA http client behaviour.","ref":"Bacen.STA.Client.html","title":"Bacen.STA.Client","type":"behaviour"},{"doc":"","ref":"Bacen.STA.Client.html#c:send_file_content/2","title":"Bacen.STA.Client.send_file_content/2","type":"callback"},{"doc":"","ref":"Bacen.STA.Client.html#c:send_protocol/1","title":"Bacen.STA.Client.send_protocol/1","type":"callback"},{"doc":"","ref":"Bacen.STA.Client.html#t:response/0","title":"Bacen.STA.Client.response/0","type":"type"},{"doc":"It's a HTTP client that talks to STA's API endpoints. Configuration config :bacen_sta , test : true , client : Bacen.STA.HTTP , credentials : [ username : &quot;username&quot; , password : &quot;password&quot; ]","ref":"Bacen.STA.HTTP.html","title":"Bacen.STA.HTTP","type":"module"},{"doc":"Send file content from given XML content for given protocol to Bacen","ref":"Bacen.STA.HTTP.html#send_file_content/2","title":"Bacen.STA.HTTP.send_file_content/2","type":"function"},{"doc":"Send file information to Bacen and retrieve the file protocol to upload content","ref":"Bacen.STA.HTTP.html#send_protocol/1","title":"Bacen.STA.HTTP.send_protocol/1","type":"function"},{"doc":"The protocol message schema for Sisbacen's server. This message is responsible to create a new protocol into Sisbacen's server to allow the application to send one of the ACCS/CCS messages for given protocol. It has the following XML examples: &lt;Parametros&gt; &lt;IdentificadorDocumento&gt;ACCS001&lt;/IdentificadorDocumento&gt; &lt;Hash&gt;1235345hfdsahgdasd214312&lt;/Hash&gt; &lt;Tamanho&gt;1234&lt;/Tamanho&gt; &lt;NomeArquivo&gt;202105072230.xml&lt;/NomeArquivo&gt; &lt;Observacao /&gt; &lt;/Parametros&gt; &lt;Parametros&gt; &lt;IdentificadorDocumento&gt;ACCS001&lt;/IdentificadorDocumento&gt; &lt;Hash&gt;1235345hfdsahgdasd214312&lt;/Hash&gt; &lt;Tamanho&gt;1234&lt;/Tamanho&gt; &lt;NomeArquivo&gt;202105072230.xml&lt;/NomeArquivo&gt; &lt;Observacao&gt;bla bla bla&lt;/Observacao&gt; &lt;/Parametros&gt; &lt;Parametros&gt; &lt;IdentificadorDocumento&gt;ACCS001&lt;/IdentificadorDocumento&gt; &lt;Hash&gt;1235345hfdsahgdasd214312&lt;/Hash&gt; &lt;Tamanho&gt;1234&lt;/Tamanho&gt; &lt;NomeArquivo&gt;202105072230.xml&lt;/NomeArquivo&gt; &lt;Observacao&gt;bla bla bla&lt;/Observacao&gt; &lt;Destinatarios&gt; &lt;Destinatario&gt; &lt;Unidade&gt;12345&lt;/Unidade&gt; &lt;Dependencia&gt;dependencia 1&lt;/Dependencia&gt; &lt;Operador&gt;operador 1&lt;/Operador&gt; &lt;/Destinatario&gt; &lt;/Destinatarios&gt; &lt;/Parametros&gt;","ref":"Bacen.STA.Protocol.html","title":"Bacen.STA.Protocol","type":"module"},{"doc":"Create new valid protocol xml from given attributes","ref":"Bacen.STA.Protocol.html#new/1","title":"Bacen.STA.Protocol.new/1","type":"function"},{"doc":"The Bacen's CCS protocol type","ref":"Bacen.STA.Protocol.html#t:t/0","title":"Bacen.STA.Protocol.t/0","type":"type"},{"doc":"","ref":"Bacen.STA.Protocol.Parameters.html","title":"Bacen.STA.Protocol.Parameters","type":"module"},{"doc":"","ref":"Bacen.STA.Protocol.Parameters.Senders.html","title":"Bacen.STA.Protocol.Parameters.Senders","type":"module"},{"doc":"","ref":"Bacen.STA.Protocol.Parameters.Senders.Sender.html","title":"Bacen.STA.Protocol.Parameters.Senders.Sender","type":"module"},{"doc":"The Protocol response message parser.","ref":"Bacen.STA.ProtocolParser.html","title":"Bacen.STA.ProtocolParser","type":"module"},{"doc":"Parses a Protocol response message schema into tuple-formatted XML. Examples iex&gt; response_xml = ~s(&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot; standalone=&quot;yes&quot;?&gt;&lt;Resultado xmlns:atom=&quot;http://www.w3.org/2005/Atom&quot;&gt;&lt;Protocolo&gt;202111172051&lt;/Protocolo&gt;&lt;atom:link href=&quot;https://sta-h.bcb.gov.br/staws/arquivos/202111172051/conteudo&quot; rel=&quot;conteudo&quot; type=&quot;application/octet-stream&quot; /&gt;&lt;/Resultado&gt;) iex&gt; Bacen.STA.ProtocolParser . parse ( response_xml ) { :ok , % Bacen.STA.Response { result : % Bacen.STA.Response.Result { protocol : &quot;202111172051&quot; } } }","ref":"Bacen.STA.ProtocolParser.html#parse/1","title":"Bacen.STA.ProtocolParser.parse/1","type":"function"},{"doc":"The Protocol message serializer.","ref":"Bacen.STA.ProtocolSerializer.html","title":"Bacen.STA.ProtocolSerializer","type":"module"},{"doc":"Serliazes a Protocol message schema into tuple-formatted XML. Examples iex&gt; protocol = % Bacen.STA.Protocol { iex&gt; parameters : % Bacen.STA.Protocol.Parameters { iex&gt; file_name : &quot;202111172051.xml&quot; , iex&gt; file_size : 908 , iex&gt; file_type : &quot;ACCS001&quot; , iex&gt; hash : &quot;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&quot; , iex&gt; observation : &quot;test&quot; , iex&gt; senders : % Bacen.STA.Protocol.Parameters.Senders { iex&gt; sender : [ iex&gt; % Bacen.STA.Protocol.Parameters.Senders.Sender { iex&gt; dependency : &quot;Dependency001&quot; , iex&gt; operator : &quot;Operator001&quot; , iex&gt; unity : &quot;Unity001&quot; iex&gt; } iex&gt; ] iex&gt; } iex&gt; } iex&gt; } iex&gt; Bacen.STA.ProtocolSerializer . serialize ( protocol ) { :ok , ~s(&lt;?xml version=&quot;1.0&quot;?&gt;&lt;Parametros&gt;&lt;IdentificadorDocumento&gt;ACCS001&lt;/IdentificadorDocumento&gt;&lt;Hash&gt;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&lt;/Hash&gt;&lt;Tamanho&gt;908&lt;/Tamanho&gt;&lt;NomeArquivo&gt;202111172051.xml&lt;/NomeArquivo&gt;&lt;Observacao&gt;test&lt;/Observacao&gt;&lt;Destinatarios&gt;&lt;Destinatario&gt;&lt;Unidade&gt;Unity001&lt;/Unidade&gt;&lt;Dependencia&gt;Dependency001&lt;/Dependencia&gt;&lt;Operador&gt;Operator001&lt;/Operador&gt;&lt;/Destinatario&gt;&lt;/Destinatarios&gt;&lt;/Parametros&gt;) } iex&gt; protocol = % Bacen.STA.Protocol { iex&gt; parameters : % Bacen.STA.Protocol.Parameters { iex&gt; file_name : &quot;202111172051.xml&quot; , iex&gt; file_size : 908 , iex&gt; file_type : &quot;ACCS001&quot; , iex&gt; hash : &quot;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&quot; , iex&gt; observation : nil , iex&gt; senders : % Bacen.STA.Protocol.Parameters.Senders { iex&gt; sender : [ iex&gt; % Bacen.STA.Protocol.Parameters.Senders.Sender { iex&gt; dependency : &quot;Dependency001&quot; , iex&gt; operator : &quot;Operator001&quot; , iex&gt; unity : &quot;Unity001&quot; iex&gt; } iex&gt; ] iex&gt; } iex&gt; } iex&gt; } iex&gt; Bacen.STA.ProtocolSerializer . serialize ( protocol ) { :ok , ~s(&lt;?xml version=&quot;1.0&quot;?&gt;&lt;Parametros&gt;&lt;IdentificadorDocumento&gt;ACCS001&lt;/IdentificadorDocumento&gt;&lt;Hash&gt;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&lt;/Hash&gt;&lt;Tamanho&gt;908&lt;/Tamanho&gt;&lt;NomeArquivo&gt;202111172051.xml&lt;/NomeArquivo&gt;&lt;Observacao/&gt;&lt;Destinatarios&gt;&lt;Destinatario&gt;&lt;Unidade&gt;Unity001&lt;/Unidade&gt;&lt;Dependencia&gt;Dependency001&lt;/Dependencia&gt;&lt;Operador&gt;Operator001&lt;/Operador&gt;&lt;/Destinatario&gt;&lt;/Destinatarios&gt;&lt;/Parametros&gt;) } iex&gt; protocol = % Bacen.STA.Protocol { iex&gt; parameters : % Bacen.STA.Protocol.Parameters { iex&gt; file_name : &quot;202111172051.xml&quot; , iex&gt; file_size : 908 , iex&gt; file_type : &quot;ACCS001&quot; , iex&gt; hash : &quot;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&quot; , iex&gt; observation : nil , iex&gt; senders : % Bacen.STA.Protocol.Parameters.Senders { sender : [ ] } iex&gt; } iex&gt; } iex&gt; Bacen.STA.ProtocolSerializer . serialize ( protocol ) { :ok , ~s(&lt;?xml version=&quot;1.0&quot;?&gt;&lt;Parametros&gt;&lt;IdentificadorDocumento&gt;ACCS001&lt;/IdentificadorDocumento&gt;&lt;Hash&gt;053c29ae8b823df65f5bff084f410ca70530c30112bc7590518fe421f4421443&lt;/Hash&gt;&lt;Tamanho&gt;908&lt;/Tamanho&gt;&lt;NomeArquivo&gt;202111172051.xml&lt;/NomeArquivo&gt;&lt;Observacao/&gt;&lt;Destinatarios/&gt;&lt;/Parametros&gt;) } iex&gt; protocol = % Bacen.STA.Protocol { parameters : % Bacen.STA.Protocol.Parameters { } } iex&gt; Bacen.STA.ProtocolSerializer . serialize ( protocol ) { :error , :invalid_parameters } iex&gt; protocol = % Bacen.STA.Protocol { } iex&gt; Bacen.STA.ProtocolSerializer . serialize ( protocol ) { :error , :invalid_protocol }","ref":"Bacen.STA.ProtocolSerializer.html#serialize/1","title":"Bacen.STA.ProtocolSerializer.serialize/1","type":"function"},{"doc":"The response message schema for Sisbacen's server. It represents the Protocol xml response from Bacen's STA system. It has the following XML example: &lt;Resultado xmlns:atom=&quot;http://www.w3.org/2005/Atom&quot;&gt; &lt;Protocolo&gt;{protocolo}&lt;/Protocolo&gt; &lt;atom:link href=&quot;https://{host}/staws/arquivos/{protocolo}/conteudo&quot; rel=&quot;conteudo&quot; type=&quot;application/octet-stream&quot; /&gt; &lt;/Resultado&gt;","ref":"Bacen.STA.Response.html","title":"Bacen.STA.Response","type":"module"},{"doc":"Create new valid protocol xml from given attributes","ref":"Bacen.STA.Response.html#new/1","title":"Bacen.STA.Response.new/1","type":"function"},{"doc":"The Bacen's CCS protocol response type","ref":"Bacen.STA.Response.html#t:t/0","title":"Bacen.STA.Response.t/0","type":"type"},{"doc":"","ref":"Bacen.STA.Response.Result.html","title":"Bacen.STA.Response.Result","type":"module"},{"doc":"The XML middleware for Tesla.","ref":"Bacen.STA.XMLMiddleware.html","title":"Bacen.STA.XMLMiddleware","type":"module"},{"doc":"Encode XML element to String","ref":"Bacen.STA.XMLMiddleware.html#encode/1","title":"Bacen.STA.XMLMiddleware.encode/1","type":"function"}]